* full outer join
sele parent.cna, kid.cnak ;
  from kid ;
    full outer join parent ;
    on kid.iidparent = parent.iidparent

* full outer join with friendly replacements for .NULL.
sele nvl(parent.cna, "No parent"), nvl(kid.cnak, "free") ;
  from kid ;
    full outer join parent ;
    on kid.iidparent = parent.iidparent

* examine the syntax
select <field> from table1 join table2 on t1.field = t2.field

join (inner join)
right join (right outer join)
left join (left outer join)
full join (full outer join)

* produces parents w/o kids
sele nvl(parent.cna, "No parent"), nvl(kid.cnak, "free") ;
  from parent left join kid ;
    on kid.iidparent = parent.iidparent

* produces kids w/o parents 
sele nvl(parent.cna, "No parent"), nvl(kid.cnak, "free") ;
  from parent right join kid ;
    on kid.iidparent = parent.iidparent

* you can't reference a table in the ON until it's been opened in a JOIN
* each JOIN/ON creates an intermediate result that is then used in the future

******** LOOK UP VALUES *************

* simple reference to a lookup table
sele parent.cna, parent.czip, itlook.cdesc ;
  from parent full outer join itlook ;
  on parent.ctypepers = itlook.ctype ;
  order by czip

* make the lookup value look nicer
sele parent.cna, parent.czip, nvl(itlook.cdesc, "n") ;
  from parent full outer join itlook ;
  on parent.ctypepers = itlook.ctype ;
  order by czip

* do more than one lookup value
* old way 
sele parent.cna, t1.cdesc as perstype, t3.cdesc as hairtype ;
  from parent, itlook t1, itlook t3 ;
  where parent.ctypepers = t1.ctype ;
    and parent.ctypehair = t3.ctype


* special case:
* join table in the middle of two other tables
* this syntax gets all parts and image names or
* "no image jack" for those parts without an image
* NOTE: the WHERE clause will cause unpredictable results
* i.e. the parent (pm) table won't have any "NO PART" records
* because we're filtering on an attribute in the PM table
* (the PL - DUH!)
 sele nvl(cnopm, "NO PART"), cdepm, nvl(cnaimage, "NO IMAGE JACK"), iidPM as cNaImage ;
   from ..\datalive\image full outer join ..\datalive\pm_im ; 
   on pm_im.iidimage = image.iidimage ;
     full outer join ..\datalive\pm on pm.iidpm = pm_im.iidpm  ;
   where pm.iidpl = m.liidPL ;
    into curs _TEMPIM
* end special case

* note: PARENT has 2079 records

* gets not all PERS, not all PERS
* result: 1732
sele parent.cna, parent.czip, ;
  parent.ctypepers, t1.cdesc as perstype, parent.ctypehair, t3.cdesc as hairtype ;
  from parent join itlook t1 ;
    on parent.ctypepers = t1.ctype ;
    join itlook t3 ;
    on parent.ctypehair = t3.ctype ;
    order by czip


* gets all PERS, not all HAIR
* result: 1876
sele parent.cna, parent.czip, ;
     parent.ctypepers, t1.cdesc as perstype, ;
     parent.ctypehair, t3.cdesc as hairtype ;
  from parent full outer join itlook t1 ;
    on parent.ctypepers = t1.ctype ;
  join itlook t3 ;
    on parent.ctypehair = t3.ctype ;
 order by czip

* gets all 
* result: 2095 (16 too many)
sele parent.cna, parent.czip, ;
     parent.ctypepers, t1.cdesc as perstype, ;
     parent.ctypehair, t3.cdesc as hairtype ;
  from parent full outer join itlook t1 ;
    on parent.ctypepers = t1.ctype ;
  full outer join itlook t3 ;
    on parent.ctypehair = t3.ctype ;
 order by czip

* alternate syntax (ANSI std)
sele parent.cna, parent.czip, ;
     parent.ctypepers, t1.cdesc as perstype, ;
     parent.ctypehair, t3.cdesc as hairtype ;
  from itlook t3 full outer join ;
         itlook t1 full outer join parent ;
         on t1.ctype = parent.ctypepers ;
    on t3.ctype = parent.ctypehair ;
 order by czip 

* the above were FULL outer joins, but we don't
* want records from ITLOOK all by themselves!!!!    
sele parent.cna, parent.czip, ;
     parent.ctypepers, t1.cdesc as perstype, ;
     parent.ctypehair, t3.cdesc as hairtype ;
  from itlook t3 RIGHT outer join ;
      itlook t1 RIGHT outer join parent ;
      on t1.ctype = parent.ctypepers ;
    on t3.ctype = parent.ctypehair ;
    order by czip

*
* four table joins
*
* produces "t1 not found"
* because first ON clause references T1 and PARENT
sele parent.cna, parent.czip, ;
     parent.ctypepers, t1.cdesc as perstype, ;
     parent.ctypehair, t3.cdesc as hairtype, ;
     parent.ctypehome, t4.cdesc as hometype ;
  from itlook t3 right outer join ;
       itlook t1 right outer join ;
       parent left outer join itlook t4;
    on t1.ctype = parent.ctypepers ;
    on t3.ctype = parent.ctypehair ;
    on t4.ctype = parent.ctypehome ;
    order by czip

* produces "t3 not found"
* we've moved T1 and T4
* but second ON clause references T3 and PARENT
sele parent.cna, parent.czip, ;
     parent.ctypepers, t1.cdesc as perstype, ;
     parent.ctypehair, t3.cdesc as hairtype, parent.ctypehome, t4.cdesc as hometype ;
  from itlook t3 right outer join ;
       itlook t1 right outer join ;
       parent left outer join itlook t4;
    on t4.ctype = parent.ctypehome ;
    on t3.ctype = parent.ctypehair ;
    on t1.ctype = parent.ctypepers ;
    order by czip

* works
* we've moved T3 and T1 so third ON clause references T3, which is opened last
sele parent.cna, parent.czip, ;
     parent.ctypepers, t1.cdesc as perstype, ;
     parent.ctypehair, t3.cdesc as hairtype, ;
     parent.ctypehome, t4.cdesc as hometype ;
  from itlook t3 right outer join ;
       itlook t1 right outer join ;
       parent left outer join itlook t4;
    on t4.ctype = parent.ctypehome ;
    on t1.ctype = parent.ctypepers ;
    on t3.ctype = parent.ctypehair ;
    order by czip
